﻿using System;
using System.Collections.Generic;
using System.Text;
//step1. reference nmodbuspc.dll, and using the namespaces.
using Modbus.Device;      //for modbus master
using System.Net;         //for tcp client
using System.Net.Sockets;

namespace coil_status
{
    class Program
    {
        static void Main(string[] args)
        {
            // connect to Modbus TCP Server
            string ipAddress = "127.0.0.1"; //Input WISE IP
            int tcpPort = 502;
            TcpClient tcpClient = new TcpClient(ipAddress, tcpPort);

            // create Modbus TCP Master by the tcp client
            //document->Modbus.Device.Namespace->ModbusIpMaster Class->Create Method
            ModbusIpMaster master = ModbusIpMaster.CreateIp(tcpClient);
                        
            // rewrite the value of address 20 (WISE DO channel 0)
            //document->Modbus.Device.Namespace->ModbusMaster Class->WriteSingleCoil Method 
            byte slaveID = 1;
            ushort rewriteAddress = 20;
            bool rewriteValue = true;
            master.WriteSingleCoil(slaveID, rewriteAddress, rewriteValue);

            // read the coil status 20~29 (00020~00029, DO ch0 ~ ch9) of the WISE module. 
            //document->Modbus.Device.Namespace->ModbusMaster Class->ReadCoils Method            
            ushort startAddress = 20;
            ushort numOfPoints = 10;         
            master.Transport.ReadTimeout = 1000;

            try
            {
                bool[] status = master.ReadCoils(slaveID, startAddress, numOfPoints);               
                for (int index = 0; index < status.Length; index++)
                    Console.WriteLine(string.Format("DO[{0}] = {1}", index, status[index]));
            }
            catch (Exception ex)
            {
                Console.WriteLine(ex.Message);
            }

            Console.WriteLine("Press enter to exit....");
            Console.ReadLine();
        }
    }
}

